diff --git a/dlls/winegstreamer/wg_transform.c b/dlls/winegstreamer/wg_transform.c
index 49c7bfaa9..b080894db 100644
--- a/dlls/winegstreamer/wg_transform.c
+++ b/dlls/winegstreamer/wg_transform.c
@@ -32,98 +32,315 @@
 #include <gst/video/video.h>
 #include <gst/audio/audio.h>
 
-#include "ntstatus.h"
-#define WIN32_NO_STATUS
 #include "winternl.h"
+#include "dshow.h"
 #include "mferror.h"
 
 #include "unix_private.h"
 
+#include "wine/list.h"
+
 GST_DEBUG_CATEGORY_EXTERN(wine);
 #define GST_CAT_DEFAULT wine
 
+struct wg_transform_sample
+{
+    struct list entry;
+    GstSample *sample;
+};
+
 struct wg_transform
 {
     GstElement *container;
     GstPad *my_src, *my_sink;
     GstPad *their_sink, *their_src;
-    GstSegment segment;
-    GstBufferList *input;
-    guint input_max_length;
-    GstAtomicQueue *output_queue;
-    GstBuffer *output_buffer;
+    pthread_mutex_t mutex;
+    struct list samples;
+    GstCaps *sink_caps;
 };
 
+static GstCaps *wg_format_to_caps_xwma(const struct wg_encoded_format *format)
+{
+    GstBuffer *buffer;
+    GstCaps *caps;
+
+    if (format->encoded_type == WG_ENCODED_TYPE_WMA)
+    {
+        caps = gst_caps_new_empty_simple("audio/x-wma");
+        if (format->u.xwma.version)
+            gst_caps_set_simple(caps, "wmaversion", G_TYPE_INT, format->u.xwma.version, NULL);
+    }
+    else
+    {
+        caps = gst_caps_new_empty_simple("audio/x-xma");
+        if (format->u.xwma.version)
+            gst_caps_set_simple(caps, "xmaversion", G_TYPE_INT, format->u.xwma.version, NULL);
+    }
+
+    if (format->u.xwma.bitrate)
+        gst_caps_set_simple(caps, "bitrate", G_TYPE_INT, format->u.xwma.bitrate, NULL);
+    if (format->u.xwma.rate)
+        gst_caps_set_simple(caps, "rate", G_TYPE_INT, format->u.xwma.rate, NULL);
+    if (format->u.xwma.depth)
+        gst_caps_set_simple(caps, "depth", G_TYPE_INT, format->u.xwma.depth, NULL);
+    if (format->u.xwma.channels)
+        gst_caps_set_simple(caps, "channels", G_TYPE_INT, format->u.xwma.channels, NULL);
+    if (format->u.xwma.block_align)
+        gst_caps_set_simple(caps, "block_align", G_TYPE_INT, format->u.xwma.block_align, NULL);
+
+    if (format->u.xwma.codec_data_len)
+    {
+        buffer = gst_buffer_new_and_alloc(format->u.xwma.codec_data_len);
+        gst_buffer_fill(buffer, 0, format->u.xwma.codec_data, format->u.xwma.codec_data_len);
+        gst_caps_set_simple(caps, "codec_data", GST_TYPE_BUFFER, buffer, NULL);
+        gst_buffer_unref(buffer);
+    }
+
+    return caps;
+}
+
+static GstCaps *wg_format_to_caps_aac(const struct wg_encoded_format *format)
+{
+    const char *profile, *level, *stream_format;
+    GstBuffer *buffer;
+    GstCaps *caps;
+
+    caps = gst_caps_new_empty_simple("audio/mpeg");
+    gst_caps_set_simple(caps, "mpegversion", G_TYPE_INT, 4, NULL);
+
+    switch (format->u.aac.payload_type)
+    {
+        case 0: stream_format = "raw"; break;
+        case 1: stream_format = "adts"; break;
+        case 2: stream_format = "adif"; break;
+        case 3: stream_format = "loas"; break;
+        default: stream_format = "raw"; break;
+    }
+    if (stream_format)
+        gst_caps_set_simple(caps, "stream-format", G_TYPE_STRING, stream_format, NULL);
+
+    switch (format->u.aac.profile_level_indication)
+    {
+        case 0x29: profile = "lc"; level = "2";  break;
+        case 0x2A: profile = "lc"; level = "4"; break;
+        case 0x2B: profile = "lc"; level = "5"; break;
+        default:
+            GST_FIXME("Unrecognized profile-level-indication %u\n", format->u.aac.profile_level_indication);
+            /* fallthrough */
+        case 0x00: case 0xFE: profile = level = NULL; break; /* unspecified */
+    }
+    if (profile)
+        gst_caps_set_simple(caps, "profile", G_TYPE_STRING, profile, NULL);
+    if (level)
+        gst_caps_set_simple(caps, "level", G_TYPE_STRING, level, NULL);
+
+    if (format->u.aac.codec_data_len)
+    {
+        buffer = gst_buffer_new_and_alloc(format->u.aac.codec_data_len);
+        gst_buffer_fill(buffer, 0, format->u.aac.codec_data, format->u.aac.codec_data_len);
+        gst_caps_set_simple(caps, "codec_data", GST_TYPE_BUFFER, buffer, NULL);
+        gst_buffer_unref(buffer);
+    }
+
+    return caps;
+}
+
+static GstCaps *wg_format_to_caps_h264(const struct wg_encoded_format *format)
+{
+    const char *profile, *level;
+    GstCaps *caps;
+
+    caps = gst_caps_new_empty_simple("video/x-h264");
+    gst_caps_set_simple(caps, "stream-format", G_TYPE_STRING, "byte-stream", NULL);
+    gst_caps_set_simple(caps, "alignment", G_TYPE_STRING, "au", NULL);
+
+    if (format->u.h264.width)
+        gst_caps_set_simple(caps, "width", G_TYPE_INT, format->u.h264.width, NULL);
+    if (format->u.h264.height)
+        gst_caps_set_simple(caps, "height", G_TYPE_INT, format->u.h264.height, NULL);
+    if (format->u.h264.fps_n || format->u.h264.fps_d)
+        gst_caps_set_simple(caps, "framerate", GST_TYPE_FRACTION, format->u.h264.fps_n, format->u.h264.fps_d, NULL);
+
+    switch (format->u.h264.profile)
+    {
+        case /* eAVEncH264VProfile_Main */ 77:  profile = "main"; break;
+        case /* eAVEncH264VProfile_High */ 100: profile = "high"; break;
+        case /* eAVEncH264VProfile_444 */  244: profile = "high-4:4:4"; break;
+        default:
+            GST_ERROR("Unrecognized H.264 profile attribute %u.", format->u.h264.profile);
+            /* fallthrough */
+        case 0: profile = NULL;
+    }
+    if (profile)
+        gst_caps_set_simple(caps, "profile", G_TYPE_STRING, profile, NULL);
+
+    switch (format->u.h264.level)
+    {
+        case /* eAVEncH264VLevel1 */   10: level = "1";   break;
+        case /* eAVEncH264VLevel1_1 */ 11: level = "1.1"; break;
+        case /* eAVEncH264VLevel1_2 */ 12: level = "1.2"; break;
+        case /* eAVEncH264VLevel1_3 */ 13: level = "1.3"; break;
+        case /* eAVEncH264VLevel2 */   20: level = "2";   break;
+        case /* eAVEncH264VLevel2_1 */ 21: level = "2.1"; break;
+        case /* eAVEncH264VLevel2_2 */ 22: level = "2.2"; break;
+        case /* eAVEncH264VLevel3 */   30: level = "3";   break;
+        case /* eAVEncH264VLevel3_1 */ 31: level = "3.1"; break;
+        case /* eAVEncH264VLevel3_2 */ 32: level = "3.2"; break;
+        case /* eAVEncH264VLevel4 */   40: level = "4";   break;
+        case /* eAVEncH264VLevel4_1 */ 41: level = "4.1"; break;
+        case /* eAVEncH264VLevel4_2 */ 42: level = "4.2"; break;
+        case /* eAVEncH264VLevel5 */   50: level = "5";   break;
+        case /* eAVEncH264VLevel5_1 */ 51: level = "5.1"; break;
+        case /* eAVEncH264VLevel5_2 */ 52: level = "5.2"; break;
+        default:
+            GST_ERROR("Unrecognized H.264 level attribute %u.", format->u.h264.level);
+            /* fallthrough */
+        case 0: level = NULL;
+    }
+    if (level)
+        gst_caps_set_simple(caps, "level", G_TYPE_STRING, level, NULL);
+
+    return caps;
+}
+
+static GstCaps *wg_encoded_format_to_caps(const struct wg_encoded_format *format)
+{
+    switch (format->encoded_type)
+    {
+        case WG_ENCODED_TYPE_UNKNOWN:
+            return NULL;
+        case WG_ENCODED_TYPE_WMA:
+        case WG_ENCODED_TYPE_XMA:
+            return wg_format_to_caps_xwma(format);
+        case WG_ENCODED_TYPE_AAC:
+            return wg_format_to_caps_aac(format);
+        case WG_ENCODED_TYPE_H264:
+            return wg_format_to_caps_h264(format);
+    }
+    assert(0);
+    return NULL;
+}
+
 static GstFlowReturn transform_sink_chain_cb(GstPad *pad, GstObject *parent, GstBuffer *buffer)
 {
     struct wg_transform *transform = gst_pad_get_element_private(pad);
+    struct wg_transform_sample *sample;
 
-    GST_LOG("transform %p, buffer %p.", transform, buffer);
+    GST_INFO("transform %p, buffer %p.", transform, buffer);
 
-    gst_atomic_queue_push(transform->output_queue, buffer);
+    if (!(sample = malloc(sizeof(*sample))))
+        GST_ERROR("Failed to allocate transform sample entry");
+    else
+    {
+        pthread_mutex_lock(&transform->mutex);
+        if (!(sample->sample = gst_sample_new(buffer, transform->sink_caps, NULL, NULL)))
+            GST_ERROR("Failed to allocate transform sample");
+        list_add_tail(&transform->samples, &sample->entry);
+        pthread_mutex_unlock(&transform->mutex);
+    }
 
+    gst_buffer_unref(buffer);
     return GST_FLOW_OK;
 }
 
+static gboolean transform_sink_event_cb(GstPad *pad, GstObject *parent, GstEvent *event)
+{
+    struct wg_transform *transform = gst_pad_get_element_private(pad);
+
+    GST_INFO("transform %p, type \"%s\".", transform, GST_EVENT_TYPE_NAME(event));
+
+    switch (event->type)
+    {
+    case GST_EVENT_CAPS:
+    {
+        GstCaps *caps;
+        gchar *str;
+
+        gst_event_parse_caps(event, &caps);
+        str = gst_caps_to_string(caps);
+        GST_WARNING("Got caps \"%s\".", str);
+        g_free(str);
+
+        pthread_mutex_lock(&transform->mutex);
+        gst_caps_unref(transform->sink_caps);
+        transform->sink_caps = gst_caps_ref(caps);
+        pthread_mutex_unlock(&transform->mutex);
+        break;
+    }
+    default:
+        GST_WARNING("Ignoring \"%s\" event.", GST_EVENT_TYPE_NAME(event));
+    }
+
+    gst_event_unref(event);
+    return TRUE;
+}
+
 NTSTATUS wg_transform_destroy(void *args)
 {
     struct wg_transform *transform = args;
-    GstBuffer *buffer;
+    struct wg_transform_sample *sample, *next;
+
+    if (transform->container)
+        gst_element_set_state(transform->container, GST_STATE_NULL);
 
-    if (transform->input)
-        gst_buffer_list_unref(transform->input);
+    if (transform->their_src && transform->my_sink)
+        gst_pad_unlink(transform->their_src, transform->my_sink);
+    if (transform->their_sink && transform->my_src)
+        gst_pad_unlink(transform->my_src, transform->their_sink);
 
-    gst_element_set_state(transform->container, GST_STATE_NULL);
+    if (transform->their_sink)
+        g_object_unref(transform->their_sink);
+    if (transform->their_src)
+        g_object_unref(transform->their_src);
 
-    if (transform->output_buffer)
-        gst_buffer_unref(transform->output_buffer);
-    while ((buffer = gst_atomic_queue_pop(transform->output_queue)))
-        gst_buffer_unref(buffer);
+    if (transform->container)
+        g_object_unref(transform->container);
 
-    g_object_unref(transform->their_sink);
-    g_object_unref(transform->their_src);
-    g_object_unref(transform->container);
-    g_object_unref(transform->my_sink);
-    g_object_unref(transform->my_src);
-    gst_atomic_queue_unref(transform->output_queue);
-    free(transform);
+    if (transform->my_sink)
+        g_object_unref(transform->my_sink);
+    if (transform->my_src)
+        g_object_unref(transform->my_src);
+
+    LIST_FOR_EACH_ENTRY_SAFE(sample, next, &transform->samples, struct wg_transform_sample, entry)
+    {
+        gst_sample_unref(sample->sample);
+        list_remove(&sample->entry);
+        free(sample);
+    }
 
-    return STATUS_SUCCESS;
+    free(transform);
+    return S_OK;
 }
 
-static GstElement *transform_find_element(GstElementFactoryListType type, GstCaps *src_caps, GstCaps *sink_caps)
+static GstElement *try_create_transform(GstCaps *src_caps, GstCaps *sink_caps)
 {
     GstElement *element = NULL;
     GList *tmp, *transforms;
-    const gchar *name;
+    gchar *type;
 
-    if (!(transforms = gst_element_factory_list_get_elements(type, GST_RANK_MARGINAL)))
-        goto done;
+    transforms = gst_element_factory_list_get_elements(GST_ELEMENT_FACTORY_TYPE_ANY,
+            GST_RANK_MARGINAL);
 
     tmp = gst_element_factory_list_filter(transforms, src_caps, GST_PAD_SINK, FALSE);
     gst_plugin_feature_list_free(transforms);
-    if (!(transforms = tmp))
-        goto done;
+    transforms = tmp;
 
     tmp = gst_element_factory_list_filter(transforms, sink_caps, GST_PAD_SRC, FALSE);
     gst_plugin_feature_list_free(transforms);
-    if (!(transforms = tmp))
-        goto done;
+    transforms = tmp;
 
     transforms = g_list_sort(transforms, gst_plugin_feature_rank_compare_func);
     for (tmp = transforms; tmp != NULL && element == NULL; tmp = tmp->next)
     {
-        name = gst_plugin_feature_get_name(GST_PLUGIN_FEATURE(tmp->data));
-        if (!(element = gst_element_factory_create(GST_ELEMENT_FACTORY(tmp->data), NULL)))
-            GST_WARNING("Failed to create %s element.", name);
+        type = gst_plugin_feature_get_name(GST_PLUGIN_FEATURE(tmp->data));
+        element = gst_element_factory_create(GST_ELEMENT_FACTORY(tmp->data), NULL);
+        if (!element)
+            GST_WARNING("Failed to create %s element.", type);
     }
     gst_plugin_feature_list_free(transforms);
 
-done:
     if (element)
-    {
-        GST_DEBUG("Created %s element %p.", name, element);
-    }
+        GST_INFO("Created %s element %p.", type, element);
     else
     {
         gchar *src_str = gst_caps_to_string(src_caps), *sink_str = gst_caps_to_string(sink_caps);
@@ -139,304 +356,275 @@ static bool transform_append_element(struct wg_transform *transform, GstElement
         GstElement **first, GstElement **last)
 {
     gchar *name = gst_element_get_name(element);
-    bool success = false;
 
-    if (!gst_bin_add(GST_BIN(transform->container), element) ||
-            (*last && !gst_element_link(*last, element)))
+    if (!gst_bin_add(GST_BIN(transform->container), element))
     {
-        GST_ERROR("Failed to link %s element.", name);
+        GST_ERROR("Failed to add %s element to bin.", name);
+        g_free(name);
+        return false;
     }
-    else
+
+    if (*last && !gst_element_link(*last, element))
     {
-        GST_DEBUG("Linked %s element %p.", name, element);
-        if (!*first)
-            *first = element;
-        *last = element;
-        success = true;
+        GST_ERROR("Failed to link %s element.", name);
+        g_free(name);
+        return false;
     }
 
+    GST_INFO("Created %s element %p.", name, element);
     g_free(name);
-    return success;
+
+    if (!*first)
+        *first = element;
+
+    *last = element;
+    return true;
 }
 
 NTSTATUS wg_transform_create(void *args)
 {
     struct wg_transform_create_params *params = args;
-    GstCaps *raw_caps = NULL, *src_caps = NULL, *sink_caps = NULL;
+    struct wg_encoded_format input_format = *params->input_format;
     struct wg_format output_format = *params->output_format;
-    struct wg_format input_format = *params->input_format;
     GstElement *first = NULL, *last = NULL, *element;
-    NTSTATUS status = STATUS_UNSUCCESSFUL;
-    GstPadTemplate *template = NULL;
+    GstCaps *raw_caps, *src_caps, *sink_caps;
     struct wg_transform *transform;
+    GstPadTemplate *template;
     const gchar *media_type;
-    GstEvent *event;
+    GstSegment *segment;
+    int i, ret;
 
     if (!init_gstreamer())
-        return STATUS_UNSUCCESSFUL;
+        return E_FAIL;
 
     if (!(transform = calloc(1, sizeof(*transform))))
-        return STATUS_NO_MEMORY;
-    if (!(transform->container = gst_bin_new("wg_transform")))
-        goto out;
-    if (!(transform->input = gst_buffer_list_new()))
-        goto out;
-    if (!(transform->output_queue = gst_atomic_queue_new(8)))
-        goto out;
-    transform->input_max_length = 1;
-
-    if (!(src_caps = wg_format_to_caps(&input_format)))
-        goto out;
-    if (!(template = gst_pad_template_new("src", GST_PAD_SRC, GST_PAD_ALWAYS, src_caps)))
-        goto out;
+        return E_OUTOFMEMORY;
+
+    list_init(&transform->samples);
+
+    src_caps = wg_encoded_format_to_caps(&input_format);
+    assert(src_caps);
+    sink_caps = wg_format_to_caps(&output_format);
+    assert(sink_caps);
+    media_type = gst_structure_get_name(gst_caps_get_structure(sink_caps, 0));
+    raw_caps = gst_caps_new_empty_simple(media_type);
+    assert(raw_caps);
+
+    transform->sink_caps = gst_caps_copy(sink_caps);
+    transform->container = gst_bin_new("wg_transform");
+    assert(transform->container);
+
+    if (!(element = try_create_transform(src_caps, raw_caps)) ||
+            !transform_append_element(transform, element, &first, &last))
+        goto failed;
+
+    switch (output_format.major_type)
+    {
+    case WG_MAJOR_TYPE_AUDIO:
+        if (!(element = create_element("audioconvert", "base")) ||
+                !transform_append_element(transform, element, &first, &last))
+            goto failed;
+        if (!(element = create_element("audioresample", "base")) ||
+                !transform_append_element(transform, element, &first, &last))
+            goto failed;
+        break;
+    case WG_MAJOR_TYPE_VIDEO:
+        if (!(element = create_element("videoconvert", "base")) ||
+                !transform_append_element(transform, element, &first, &last))
+            goto failed;
+        for (i = 0; i < gst_caps_get_size(sink_caps); ++i)
+            gst_structure_remove_fields(gst_caps_get_structure(sink_caps, i),
+                    "width", "height", NULL);
+        break;
+    default:
+        assert(0);
+        break;
+    }
+
+    if (!(transform->their_sink = gst_element_get_static_pad(first, "sink")))
+    {
+        GST_ERROR("Failed to find target sink pad.");
+        goto failed;
+    }
+    if (!(transform->their_src = gst_element_get_static_pad(last, "src")))
+    {
+        GST_ERROR("Failed to find target src pad.");
+        goto failed;
+    }
+
+    template = gst_pad_template_new("src", GST_PAD_SRC, GST_PAD_ALWAYS, src_caps);
+    assert(template);
     transform->my_src = gst_pad_new_from_template(template, "src");
     g_object_unref(template);
-    if (!transform->my_src)
-        goto out;
+    assert(transform->my_src);
 
-    if (!(sink_caps = wg_format_to_caps(&output_format)))
-        goto out;
-    if (!(template = gst_pad_template_new("sink", GST_PAD_SINK, GST_PAD_ALWAYS, sink_caps)))
-        goto out;
+    template = gst_pad_template_new("sink", GST_PAD_SINK, GST_PAD_ALWAYS, sink_caps);
+    assert(template);
     transform->my_sink = gst_pad_new_from_template(template, "sink");
     g_object_unref(template);
-    if (!transform->my_sink)
-        goto out;
+    assert(transform->my_sink);
 
     gst_pad_set_element_private(transform->my_sink, transform);
+    gst_pad_set_event_function(transform->my_sink, transform_sink_event_cb);
     gst_pad_set_chain_function(transform->my_sink, transform_sink_chain_cb);
 
-    /* Since we append conversion elements, we don't want to filter decoders
-     * based on the actual output caps now. Matching decoders with the
-     * raw output media type should be enough.
-     */
-    media_type = gst_structure_get_name(gst_caps_get_structure(sink_caps, 0));
-    if (!(raw_caps = gst_caps_new_empty_simple(media_type)))
-        goto out;
-
-    switch (input_format.major_type)
-    {
-        case WG_MAJOR_TYPE_H264:
-            /* Call of Duty: Black Ops 3 doesn't care about the ProcessInput/ProcessOutput
-             * return values, it calls them in a specific order and expects the decoder
-             * transform to be able to queue its input buffers. We need to use a buffer list
-             * to match its expectations.
-             */
-            transform->input_max_length = 16;
-            /* fallthrough */
-        case WG_MAJOR_TYPE_WMA:
-            if (!(element = transform_find_element(GST_ELEMENT_FACTORY_TYPE_DECODER, src_caps, raw_caps))
-                    || !transform_append_element(transform, element, &first, &last))
-            {
-                gst_caps_unref(raw_caps);
-                goto out;
-            }
-            break;
-
-        case WG_MAJOR_TYPE_AUDIO:
-        case WG_MAJOR_TYPE_VIDEO:
-        case WG_MAJOR_TYPE_UNKNOWN:
-            GST_FIXME("Format %u not implemented!", input_format.major_type);
-            gst_caps_unref(raw_caps);
-            goto out;
+    if ((ret = gst_pad_link(transform->my_src, transform->their_sink)) < 0)
+    {
+        GST_ERROR("Failed to link sink pads, error %d.", ret);
+        goto failed;
+    }
+    if ((ret = gst_pad_link(transform->their_src, transform->my_sink)) < 0)
+    {
+        GST_ERROR("Failed to link source pads, error %d.", ret);
+        goto failed;
     }
 
-    gst_caps_unref(raw_caps);
+    if (!(ret = gst_pad_set_active(transform->my_sink, 1)))
+        GST_WARNING("Failed to activate my_sink.");
+    if (!(ret = gst_pad_set_active(transform->my_src, 1)))
+        GST_WARNING("Failed to activate my_src.");
 
-    switch (output_format.major_type)
+    gst_element_set_state(transform->container, GST_STATE_PAUSED);
+    ret = gst_element_get_state(transform->container, NULL, NULL, -1);
+    if (ret == GST_STATE_CHANGE_FAILURE)
     {
-        case WG_MAJOR_TYPE_AUDIO:
-            /* The MF audio decoder transforms allow decoding to various formats
-             * as well as resampling the audio at the same time, whereas
-             * GStreamer decoder plugins usually only support decoding to a
-             * single format and at the original rate.
-             *
-             * The WMA decoder transform also has output samples interleaved on
-             * Windows, whereas GStreamer avdec_wmav2 output uses
-             * non-interleaved format.
-             */
-            if (!(element = create_element("audioconvert", "base"))
-                    || !transform_append_element(transform, element, &first, &last))
-                goto out;
-            if (!(element = create_element("audioresample", "base"))
-                    || !transform_append_element(transform, element, &first, &last))
-                goto out;
-            break;
-
-        case WG_MAJOR_TYPE_VIDEO:
-            break;
-
-        case WG_MAJOR_TYPE_H264:
-        case WG_MAJOR_TYPE_WMA:
-        case WG_MAJOR_TYPE_UNKNOWN:
-            GST_FIXME("Format %u not implemented!", output_format.major_type);
-            goto out;
+        GST_ERROR("Failed to play stream.\n");
+        goto failed;
     }
 
-    if (!(transform->their_sink = gst_element_get_static_pad(first, "sink")))
-        goto out;
-    if (!(transform->their_src = gst_element_get_static_pad(last, "src")))
-        goto out;
-    if (gst_pad_link(transform->my_src, transform->their_sink) < 0)
-        goto out;
-    if (gst_pad_link(transform->their_src, transform->my_sink) < 0)
-        goto out;
-    if (!gst_pad_set_active(transform->my_sink, 1))
-        goto out;
-    if (!gst_pad_set_active(transform->my_src, 1))
-        goto out;
+    if (!gst_pad_push_event(transform->my_src, gst_event_new_stream_start("stream")))
+    {
+        GST_ERROR("Failed to send stream-start.");
+        goto failed;
+    }
 
-    gst_element_set_state(transform->container, GST_STATE_PAUSED);
-    if (!gst_element_get_state(transform->container, NULL, NULL, -1))
-        goto out;
-
-    if (!(event = gst_event_new_stream_start("stream"))
-            || !gst_pad_push_event(transform->my_src, event))
-        goto out;
-    if (!(event = gst_event_new_caps(src_caps))
-            || !gst_pad_push_event(transform->my_src, event))
-        goto out;
-
-    /* We need to use GST_FORMAT_TIME here because it's the only format
-     * some elements such avdec_wmav2 correctly support. */
-    gst_segment_init(&transform->segment, GST_FORMAT_TIME);
-    transform->segment.start = 0;
-    transform->segment.stop = -1;
-    if (!(event = gst_event_new_segment(&transform->segment))
-            || !gst_pad_push_event(transform->my_src, event))
-        goto out;
+    if (!gst_pad_push_event(transform->my_src, gst_event_new_caps(src_caps)) ||
+        !gst_pad_has_current_caps(transform->their_sink))
+    {
+        GST_ERROR("Failed to set stream caps.");
+        goto failed;
+    }
 
-    gst_caps_unref(sink_caps);
-    gst_caps_unref(src_caps);
+    segment = gst_segment_new();
+    gst_segment_init(segment, GST_FORMAT_TIME);
+    segment->start = 0;
+    segment->stop = -1;
+    ret = gst_pad_push_event(transform->my_src, gst_event_new_segment(segment));
+    gst_segment_free(segment);
+    if (!ret)
+    {
+        GST_ERROR("Failed to start new segment.");
+        goto failed;
+    }
 
     GST_INFO("Created winegstreamer transform %p.", transform);
     params->transform = transform;
-    return STATUS_SUCCESS;
 
-out:
-    if (transform->their_sink)
-        gst_object_unref(transform->their_sink);
-    if (transform->their_src)
-        gst_object_unref(transform->their_src);
-    if (transform->my_sink)
-        gst_object_unref(transform->my_sink);
-    if (sink_caps)
-        gst_caps_unref(sink_caps);
-    if (transform->my_src)
-        gst_object_unref(transform->my_src);
-    if (src_caps)
-        gst_caps_unref(src_caps);
-    if (transform->output_queue)
-        gst_atomic_queue_unref(transform->output_queue);
-    if (transform->input)
-        gst_buffer_list_unref(transform->input);
-    if (transform->container)
-    {
-        gst_element_set_state(transform->container, GST_STATE_NULL);
-        gst_object_unref(transform->container);
-    }
-    free(transform);
-    GST_ERROR("Failed to create winegstreamer transform.");
-    return status;
+failed:
+    gst_caps_unref(raw_caps);
+    gst_caps_unref(src_caps);
+    gst_caps_unref(sink_caps);
+
+    if (params->transform)
+        return S_OK;
+
+    wg_transform_destroy(transform);
+    return E_FAIL;
 }
 
 NTSTATUS wg_transform_push_data(void *args)
 {
     struct wg_transform_push_data_params *params = args;
     struct wg_transform *transform = params->transform;
-    struct wg_sample *sample = params->sample;
     GstBuffer *buffer;
-    guint length;
+    GstFlowReturn ret;
 
-    length = gst_buffer_list_length(transform->input);
-    if (length >= transform->input_max_length)
-    {
-        GST_INFO("Refusing %u bytes, %u buffers already queued", sample->size, length);
-        params->result = MF_E_NOTACCEPTING;
-        return STATUS_SUCCESS;
-    }
+    buffer = gst_buffer_new_and_alloc(params->size);
+    gst_buffer_fill(buffer, 0, params->data, params->size);
 
-    if (!(buffer = gst_buffer_new_and_alloc(sample->size)))
+    ret = gst_pad_push(transform->my_src, buffer);
+    if (ret)
     {
-        GST_ERROR("Failed to allocate input buffer");
-        return STATUS_NO_MEMORY;
+        GST_ERROR("Failed to push buffer %d", ret);
+        return MF_E_NOTACCEPTING;
     }
-    gst_buffer_fill(buffer, 0, sample->data, sample->size);
-    gst_buffer_list_insert(transform->input, -1, buffer);
 
-    GST_INFO("Copied %u bytes from sample %p to input buffer list", sample->size, sample);
-    params->result = S_OK;
-    return STATUS_SUCCESS;
+    GST_INFO("Pushed %u bytes", params->size);
+    return S_OK;
 }
 
-static NTSTATUS read_transform_output_data(GstBuffer *buffer, struct wg_sample *sample)
+NTSTATUS wg_transform_read_data(void *args)
 {
+    struct wg_transform_read_data_params *params = args;
+    struct wg_transform *transform = params->transform;
+    struct wg_sample *read_sample = params->sample;
+    struct wg_transform_sample *transform_sample;
+    struct wg_format buffer_format;
+    bool broken_timestamp = false;
+    GstBuffer *buffer;
+    struct list *head;
     GstMapInfo info;
+    GstCaps *caps;
 
-    if (!gst_buffer_map(buffer, &info, GST_MAP_READ))
+    pthread_mutex_lock(&transform->mutex);
+    if (!(head = list_head(&transform->samples)))
     {
-        GST_ERROR("Failed to map buffer %p", buffer);
-        return STATUS_UNSUCCESSFUL;
+        pthread_mutex_unlock(&transform->mutex);
+        return MF_E_TRANSFORM_NEED_MORE_INPUT;
     }
 
-    if (sample->max_size >= info.size)
-        sample->size = info.size;
-    else
+    transform_sample = LIST_ENTRY(head, struct wg_transform_sample, entry);
+    buffer = gst_sample_get_buffer(transform_sample->sample);
+
+    if (read_sample->format)
     {
-        sample->flags |= WG_SAMPLE_FLAG_INCOMPLETE;
-        sample->size = sample->max_size;
+        if (!(caps = gst_sample_get_caps(transform_sample->sample)))
+            caps = transform->sink_caps;
+        wg_format_from_caps(&buffer_format, caps);
+        if (!wg_format_compare(read_sample->format, &buffer_format))
+        {
+            *read_sample->format = buffer_format;
+            read_sample->size = gst_buffer_get_size(buffer);
+            pthread_mutex_unlock(&transform->mutex);
+            return MF_E_TRANSFORM_STREAM_CHANGE;
+        }
+
+        if (buffer_format.major_type == WG_MAJOR_TYPE_VIDEO
+                && buffer_format.u.video.fps_n <= 1
+                && buffer_format.u.video.fps_d <= 1)
+            broken_timestamp = true;
     }
 
-    memcpy(sample->data, info.data, sample->size);
+    gst_buffer_map(buffer, &info, GST_MAP_READ);
+    if (read_sample->size > info.size)
+        read_sample->size = info.size;
+    memcpy(read_sample->data, info.data, read_sample->size);
     gst_buffer_unmap(buffer, &info);
-    gst_buffer_resize(buffer, sample->size, -1);
-
-    GST_INFO("Copied %u bytes, sample %p, flags %#x", sample->size, sample, sample->flags);
-    return STATUS_SUCCESS;
-}
-
-NTSTATUS wg_transform_read_data(void *args)
-{
-    struct wg_transform_read_data_params *params = args;
-    struct wg_transform *transform = params->transform;
-    struct wg_sample *sample = params->sample;
-    GstBufferList *input = transform->input;
-    GstFlowReturn ret;
-    NTSTATUS status;
 
-    if (!gst_buffer_list_length(transform->input))
-        GST_DEBUG("Not input buffer queued");
-    else if (!(transform->input = gst_buffer_list_new()))
+    if (buffer->pts != GST_CLOCK_TIME_NONE && !broken_timestamp)
     {
-        GST_ERROR("Failed to allocate new input queue");
-        return STATUS_NO_MEMORY;
+        read_sample->flags |= WG_SAMPLE_FLAG_HAS_PTS;
+        read_sample->pts = buffer->pts / 100;
     }
-    else if ((ret = gst_pad_push_list(transform->my_src, input)))
+    if (buffer->duration != GST_CLOCK_TIME_NONE && !broken_timestamp)
     {
-        GST_ERROR("Failed to push transform input, error %d", ret);
-        return STATUS_UNSUCCESSFUL;
+        read_sample->flags |= WG_SAMPLE_FLAG_HAS_DURATION;
+        read_sample->duration = buffer->duration / 100;
     }
 
-    if (!transform->output_buffer && !(transform->output_buffer = gst_atomic_queue_pop(transform->output_queue)))
+    if (info.size > read_sample->size)
     {
-        sample->size = 0;
-        params->result = MF_E_TRANSFORM_NEED_MORE_INPUT;
-        GST_INFO("Cannot read %u bytes, no output available", sample->max_size);
-        return STATUS_SUCCESS;
+        read_sample->flags |= WG_SAMPLE_FLAG_INCOMPLETE;
+        gst_buffer_resize(buffer, read_sample->size, -1);
     }
-
-    if ((status = read_transform_output_data(transform->output_buffer, sample)))
-    {
-        sample->size = 0;
-        return status;
-    }
-
-    if (!(sample->flags & WG_SAMPLE_FLAG_INCOMPLETE))
+    else
     {
-        gst_buffer_unref(transform->output_buffer);
-        transform->output_buffer = NULL;
+        gst_sample_unref(transform_sample->sample);
+        list_remove(&transform_sample->entry);
+        free(transform_sample);
     }
+    pthread_mutex_unlock(&transform->mutex);
 
-    params->result = S_OK;
-    return STATUS_SUCCESS;
+    GST_INFO("Read %u bytes, flags %#x", read_sample->size, read_sample->flags);
+    return S_OK;
 }
